// SPDX-FileCopyrightText: Copyright (c) Ken Martin, Will Schroeder, Bill Lorensen
// SPDX-License-Identifier: BSD-3-Clause

#ifndef vtkRenderingVRObjectFactory_h
#define vtkRenderingVRObjectFactory_h

#include "vtkRenderingVRModule.h" // For export macro
#include "vtkObjectFactory.h"

VTK_ABI_NAMESPACE_BEGIN

class VTKRENDERINGVR_EXPORT vtkRenderingVRObjectFactory : public vtkObjectFactory
{
public:
  static vtkRenderingVRObjectFactory * New();
  vtkTypeMacro(vtkRenderingVRObjectFactory, vtkObjectFactory);

  const char * GetDescription() override { return "vtkRenderingVR factory overrides."; }

  const char * GetVTKSourceVersion() override;

  void PrintSelf(ostream &os, vtkIndent indent) override;

protected:
  vtkRenderingVRObjectFactory();

private:
  vtkRenderingVRObjectFactory(const vtkRenderingVRObjectFactory&) = delete;
  void operator=(const vtkRenderingVRObjectFactory&) = delete;
};

VTK_ABI_NAMESPACE_END

#endif // vtkRenderingVRObjectFactory_h
